diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ICdmMassIndexer.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ICdmMassIndexer.java
index 9b55e2c2be..fd8d56f540 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ICdmMassIndexer.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ICdmMassIndexer.java
@@ -16,9 +16,10 @@ public interface ICdmMassIndexer {
     /**
      * Reindex all cdm entities listed in {@link ICdmMassIndexer#indexedClasses()}.
      * Re-indexing will not purge the index.
+     * @param types TODO
      * @param monitor TODO
      */
-    public abstract void reindex(IProgressMonitor monitor);
+    public abstract void reindex(Set<Class<? extends CdmBase>> types, IProgressMonitor monitor);
 
     /**
      * This will wipe out the index.
@@ -31,25 +32,14 @@ public interface ICdmMassIndexer {
      * @return a List of {@link CdmBase} sub classes
      */
     public Set<Class<? extends CdmBase>> indexedClasses();
-    
-    /**
-     * Adds to the current list of (sub-classes of CdmBase) classes to be indexed.
-     *
-     * @param cdmBaseClass sub-class of CdmBase class to add
-     */
-    public void addToIndexedClasses(Class<? extends CdmBase> cdmBaseClass);
-    
-    /**
-     * Clears the current list of (sub-classes of CdmBase) classes to be indexed.     
-     */
-    public void clearIndexedClasses();
+
     /**
      * Create (spell-checking) dictionary listed in {@link ICdmMassIndexer#dictionaryClasses()}.
      * This action will not purge the dictionary.
      * @param monitor TODO
      */
     public abstract void createDictionary(IProgressMonitor monitor);
-    
+
     public Class[] dictionaryClasses();
 
 }
\ No newline at end of file
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ILuceneIndexToolProvider.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ILuceneIndexToolProvider.java
new file mode 100644
index 0000000000..a699d0f887
--- /dev/null
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ILuceneIndexToolProvider.java
@@ -0,0 +1,66 @@
+// $Id$
+/**
+ * Copyright (C) 2013 EDIT
+ * European Distributed Institute of Taxonomy
+ * http://www.e-taxonomy.eu
+ *
+ * The contents of this file are subject to the Mozilla Public License Version 1.1
+ * See LICENSE.TXT at the top of this package for the full license terms.
+ */
+package eu.etaxonomy.cdm.api.service.search;
+
+import org.apache.lucene.analysis.Analyzer;
+import org.apache.lucene.index.IndexReader;
+import org.apache.lucene.queryParser.QueryParser;
+import org.hibernate.search.indexes.IndexReaderAccessor;
+
+import eu.etaxonomy.cdm.model.common.CdmBase;
+
+/**
+ * @author a.kohlbecker
+ * @date Sep 18, 2013
+ *
+ */
+public interface ILuceneIndexToolProvider {
+
+    /**
+     * @return the IndexReader suitable for the lucene index of the given
+     *         <code>clazz</code>
+     */
+    public abstract IndexReader getIndexReaderFor(Class<? extends CdmBase> clazz);
+
+    /**
+     * Either creates a new QueryParser or returns the QueryParser which has
+     * been created before for the specified class. The QueryParsers per CdmBase
+     * type are cached in a Map.
+     *
+     * @return the QueryParser suitable for the lucene index of the given
+     *         <code>clazz</code>
+     */
+    public abstract QueryParser getQueryParserFor(Class<? extends CdmBase> clazz);
+
+    /**
+     * <b>WARING</b> The implementation of this method might return an Analyzer
+     * which is not suitable for all fields of the lucene document. This method
+     * internally uses the simplified method from {@link {
+     * @link org.hibernate.search.SearchFactory#getAnalyzer(Class)}
+     *
+     * @return the Analyzer suitable for the lucene index of the given
+     *         <code>clazz</code>
+     */
+    public abstract Analyzer getAnalyzerFor(Class<? extends CdmBase> clazz);
+
+    /**
+     * Creates new QueryFactory for the specified Cdm type.
+     *
+     * @return A new QueryFactory suitable for the lucene index of the given
+     *         <code>clazz</code>
+     */
+    public abstract QueryFactory newQueryFactoryFor(Class<? extends CdmBase> clazz);
+
+    /**
+     * @return the IndexReaderAccessor from the SearchFactory
+     */
+    public abstract IndexReaderAccessor getIndexReaderAccessor();
+
+}
\ No newline at end of file
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneIndexToolProviderImpl.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneIndexToolProviderImpl.java
new file mode 100644
index 0000000000..3fb815dd42
--- /dev/null
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneIndexToolProviderImpl.java
@@ -0,0 +1,139 @@
+// $Id$
+/**
+ * Copyright (C) 2013 EDIT
+ * European Distributed Institute of Taxonomy
+ * http://www.e-taxonomy.eu
+ *
+ * The contents of this file are subject to the Mozilla Public License Version 1.1
+ * See LICENSE.TXT at the top of this package for the full license terms.
+ */
+package eu.etaxonomy.cdm.api.service.search;
+
+import java.util.HashMap;
+import java.util.Map;
+
+import org.apache.lucene.analysis.Analyzer;
+import org.apache.lucene.index.IndexReader;
+import org.apache.lucene.queryParser.QueryParser;
+import org.hibernate.SessionFactory;
+import org.hibernate.search.Search;
+import org.hibernate.search.SearchFactory;
+import org.hibernate.search.indexes.IndexReaderAccessor;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.stereotype.Component;
+
+import eu.etaxonomy.cdm.config.Configuration;
+import eu.etaxonomy.cdm.model.common.CdmBase;
+import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
+import eu.etaxonomy.cdm.model.description.TextData;
+import eu.etaxonomy.cdm.model.name.NonViralName;
+import eu.etaxonomy.cdm.model.name.TaxonNameBase;
+import eu.etaxonomy.cdm.model.taxon.Taxon;
+import eu.etaxonomy.cdm.model.taxon.TaxonBase;
+
+/**
+ * @author a.kohlbecker
+ * @date Sep 18, 2013
+ *
+ */
+@Component
+public class LuceneIndexToolProviderImpl implements ILuceneIndexToolProvider {
+
+    private final static String DEFAULT_QURERY_FIELD_NAME = "titleCache";
+
+    @Autowired
+    private SessionFactory sessionFactory;
+
+    private final Map<Class<? extends CdmBase>, QueryParser> queryParsers = new HashMap<Class<? extends CdmBase>, QueryParser>();
+
+    /**
+     * @param sessionfactory
+     * @return
+     */
+    private SearchFactory getCurrentSearchFactory() {
+        return Search.getFullTextSession(sessionFactory.getCurrentSession()).getSearchFactory();
+    }
+
+
+    /**
+     * TODO the abstract base class DescriptionElementBase can not be used, so
+     * we are using an arbitrary subclass to find the DirectoryProvider, future
+     * versions of hibernate search my allow using abstract base classes see
+     * {@link http://stackoverflow.com/questions/492184/how-do-you-find-all-subclasses-of-a-given-class-in-java}
+     *
+     * @param type must not be null
+     * @return
+     */
+    protected Class<? extends CdmBase> pushAbstractBaseTypeDown(Class<? extends CdmBase> type) {
+        if(type == null) {
+            throw new NullPointerException("parameter type must not be null");
+        }
+        if (type.equals(DescriptionElementBase.class)) {
+            return TextData.class;
+        }
+        if (type.equals(TaxonBase.class)) {
+            return Taxon.class;
+        }
+        if (type.equals(TaxonNameBase.class)) {
+            return NonViralName.class;
+        }
+        return type;
+    }
+
+    /* (non-Javadoc)
+     * @see eu.etaxonomy.cdm.api.service.search.ILuceneIndexToolProvider#getIndexReaderFor(java.lang.Class)
+     */
+    @Override
+    public IndexReader getIndexReaderFor(Class<? extends CdmBase> clazz) {
+        IndexReader reader = getCurrentSearchFactory().getIndexReaderAccessor().open(pushAbstractBaseTypeDown(clazz));
+        return reader;
+    }
+
+    /* (non-Javadoc)
+     * @see eu.etaxonomy.cdm.api.service.search.ILuceneIndexToolProvider#getQueryParserFor(java.lang.Class)
+     */
+    @Override
+    public QueryParser getQueryParserFor(Class<? extends CdmBase> clazz) {
+        if(!queryParsers.containsKey(clazz)){
+            Analyzer analyzer = getAnalyzerFor(clazz);
+            QueryParser parser = new QueryParser(Configuration.luceneVersion, DEFAULT_QURERY_FIELD_NAME, analyzer);
+            queryParsers.put(clazz, parser);
+        }
+        return queryParsers.get(clazz);
+    }
+
+    /**
+     * <b>WARING</b> This method might return an Analyzer
+     * which is not suitable for all fields of the lucene document. This method
+     * internally uses the simplified method from {@link {
+     * @link org.hibernate.search.SearchFactory#getAnalyzer(Class)}
+     *
+     * TODO implement method which allows to retrieve the correct Analyzer
+     * per document field, this method will have another signature.
+     *
+     * @return the Analyzer suitable for the lucene index of the given
+     *         <code>clazz</code>
+     */
+    @Override
+    public Analyzer getAnalyzerFor(Class<? extends CdmBase> clazz) {
+        Analyzer analyzer = getCurrentSearchFactory().getAnalyzer(pushAbstractBaseTypeDown(clazz));
+        return analyzer;
+    }
+
+    /* (non-Javadoc)
+     * @see eu.etaxonomy.cdm.api.service.search.ILuceneIndexToolProvider#getQueryFactoryFor(java.lang.Class)
+     */
+    @Override
+    public QueryFactory newQueryFactoryFor(Class<? extends CdmBase> clazz){
+        return new QueryFactory(this, pushAbstractBaseTypeDown(clazz));
+    }
+
+    /* (non-Javadoc)
+     * @see eu.etaxonomy.cdm.api.service.search.ILuceneIndexToolProvider#getIndexReaderAccessor()
+     */
+    @Override
+    public IndexReaderAccessor getIndexReaderAccessor(){
+        return getCurrentSearchFactory().getIndexReaderAccessor();
+    }
+
+}
\ No newline at end of file
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneMultiSearch.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneMultiSearch.java
index a386f3435d..536ea4c8a8 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneMultiSearch.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneMultiSearch.java
@@ -22,8 +22,7 @@ import org.apache.lucene.index.MultiReader;
 import org.apache.lucene.search.BooleanClause.Occur;
 import org.apache.lucene.search.BooleanQuery;
 import org.apache.lucene.search.IndexSearcher;
-import org.hibernate.search.Search;
-import org.hibernate.search.SearchFactory;
+import org.apache.lucene.search.SortField;
 import org.hibernate.search.indexes.IndexReaderAccessor;
 
 import eu.etaxonomy.cdm.model.common.CdmBase;
@@ -40,28 +39,64 @@ public class LuceneMultiSearch extends LuceneSearch {
 
     public static final Logger logger = Logger.getLogger(LuceneMultiSearch.class);
 
-    private Set<Class<? extends CdmBase>> directorySelectClasses = new HashSet<Class<? extends CdmBase>>();
+    private final Set<Class<? extends CdmBase>> directorySelectClasses = new HashSet<Class<? extends CdmBase>>();
 
 
     /**
      * @param luceneSearch the searches to execute together as a union like search
+     * @throws Exception
      */
-    public LuceneMultiSearch(LuceneSearch... luceneSearch) {
-        session = luceneSearch[0].session;
+    public LuceneMultiSearch(ILuceneIndexToolProvider toolProvider, LuceneSearch... luceneSearch) throws LuceneMultiSearchException {
 
+        this.toolProvider = toolProvider;
+        groupByField = null; //reset
         BooleanQuery query = new BooleanQuery();
 
         Set<String> highlightFields = new HashSet<String>();
+        List<SortField> multiSearcherSortFields = new ArrayList<SortField>();
 
         for(LuceneSearch search : luceneSearch){
+
             this.directorySelectClasses.add(search.getDirectorySelectClass());
             query.add(search.getQuery(), Occur.SHOULD);
+
+            // add the highlightFields from each of the sub searches
             highlightFields.addAll(Arrays.asList(search.getHighlightFields()));
+
+            // set the class for each of the sub searches
+            if(search.cdmTypeRestriction != null){
+                if(cdmTypeRestriction != null && !cdmTypeRestriction.equals(search.cdmTypeRestriction)){
+                    throw new LuceneMultiSearchException(
+                            "LuceneMultiSearch can only handle once class restriction, but multiple given: " +
+                            getCdmTypRestriction() + ", " + search.getCdmTypRestriction());
+                }
+                setCdmTypRestriction(search.getCdmTypRestriction());
+            }
+
+            // set the groupByField for each of the sub searches
+            if(search.groupByField != null){
+                if(groupByField != null && !groupByField.equals(search.groupByField)){
+                    throw new LuceneMultiSearchException(
+                            "LuceneMultiSearch can only handle once groupByField, but multiple given: " +
+                            groupByField + ", " + search.groupByField);
+                }
+                groupByField = search.groupByField;
+            }
+
+
+            // add the sort field from each of the sub searches
+            if(search.getSortFields() != null) {
+                for(SortField addField : search.getSortFields()){
+                    if(! multiSearcherSortFields.contains(addField)) {
+                        multiSearcherSortFields.add(addField);
+                    }
+                }
+            }
         }
 
+        this.sortFields = multiSearcherSortFields.toArray(new SortField[multiSearcherSortFields.size()]);
         this.highlightFields = highlightFields.toArray(new String[highlightFields.size()]);
         this.query = query;
-
     }
 
     /**
@@ -71,19 +106,17 @@ public class LuceneMultiSearch extends LuceneSearch {
     public IndexSearcher getSearcher() {
 
         if(searcher == null){
-
-            SearchFactory searchFactory = Search.getFullTextSession(session).getSearchFactory();
             List<IndexReader> readers = new ArrayList<IndexReader>();
             for(Class<? extends CdmBase> type : directorySelectClasses){
-            	   //OLD
+                   //OLD
 //                DirectoryProvider[] directoryProviders = searchFactory.getDirectoryProviders(type);
 //                logger.info(directoryProviders[0].getDirectory().toString());
 
 //                ReaderProvider readerProvider = searchFactory.getReaderProvider();
-            	IndexReaderAccessor ira = searchFactory.getIndexReaderAccessor(); 
-            	IndexReader reader = ira.open(type);
+                IndexReaderAccessor ira = toolProvider.getIndexReaderAccessor();
+                IndexReader reader = ira.open(type);
 //            	readers.add(readerProvider.openReader(directoryProviders[0]));
-            	readers.add(reader);
+                readers.add(reader);
             }
             if(readers.size() > 1){
                 MultiReader multireader = new MultiReader(readers.toArray(new IndexReader[readers.size()]), true);
@@ -105,10 +138,9 @@ public class LuceneMultiSearch extends LuceneSearch {
      */
     @Override
     public Analyzer getAnalyzer() {
-        SearchFactory searchFactory = Search.getFullTextSession(session).getSearchFactory();
         Analyzer analyzer = null;
         for(Class<? extends CdmBase> type : directorySelectClasses){
-            Analyzer a = searchFactory.getAnalyzer(type);
+            Analyzer a = toolProvider.getAnalyzerFor(type);
             if(isEqual(analyzer, a)){
                 throw new RuntimeException("The LuceneMultiSearch must only be used on indexes which are using the same Analyzer.");
             }
@@ -117,6 +149,7 @@ public class LuceneMultiSearch extends LuceneSearch {
         return analyzer;
     }
 
+
     /**
      * @param analyzer
      * @param a
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneMultiSearchException.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneMultiSearchException.java
new file mode 100644
index 0000000000..c79fd44e52
--- /dev/null
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneMultiSearchException.java
@@ -0,0 +1,26 @@
+/**
+ * Copyright (C) 2013 EDIT
+ * European Distributed Institute of Taxonomy
+ * http://www.e-taxonomy.eu
+ *
+ * The contents of this file are subject to the Mozilla Public License Version 1.1
+ * See LICENSE.TXT at the top of this package for the full license terms.
+ */
+package eu.etaxonomy.cdm.api.service.search;
+
+/**
+ * @author a.kohlbecker
+ * @date Sep 10, 2013
+ *
+ */
+@SuppressWarnings("serial")
+public class LuceneMultiSearchException extends Exception {
+
+    /**
+     * @param string
+     */
+    public LuceneMultiSearchException(String string) {
+        super(string);
+    }
+
+}
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneSearch.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneSearch.java
index fbdf828f20..750fc2e491 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneSearch.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneSearch.java
@@ -14,18 +14,13 @@ import java.util.Collection;
 
 import org.apache.log4j.Logger;
 import org.apache.lucene.analysis.Analyzer;
-import org.apache.lucene.index.IndexReader;
-import org.apache.lucene.index.Term;
 import org.apache.lucene.queryParser.ParseException;
-import org.apache.lucene.queryParser.QueryParser;
-import org.apache.lucene.search.BooleanClause;
-import org.apache.lucene.search.BooleanQuery;
+import org.apache.lucene.search.Filter;
 import org.apache.lucene.search.IndexSearcher;
 import org.apache.lucene.search.MultiCollector;
 import org.apache.lucene.search.Query;
 import org.apache.lucene.search.Sort;
 import org.apache.lucene.search.SortField;
-import org.apache.lucene.search.TermQuery;
 import org.apache.lucene.search.TopDocs;
 import org.apache.lucene.search.grouping.GroupDocs;
 import org.apache.lucene.search.grouping.SearchGroup;
@@ -33,12 +28,7 @@ import org.apache.lucene.search.grouping.TermAllGroupsCollector;
 import org.apache.lucene.search.grouping.TermFirstPassGroupingCollector;
 import org.apache.lucene.search.grouping.TermSecondPassGroupingCollector;
 import org.apache.lucene.search.grouping.TopGroups;
-import org.hibernate.Session;
-import org.hibernate.search.ProjectionConstants;
-import org.hibernate.search.Search;
-import org.hibernate.search.SearchFactory;
 
-import eu.etaxonomy.cdm.config.Configuration;
 import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.TextData;
@@ -55,20 +45,22 @@ import eu.etaxonomy.cdm.model.taxon.TaxonBase;
  */
 public class LuceneSearch {
 
-    private String groupByField = "id";
+    protected String groupByField = "id";
 
     public final static String ID_FIELD = "id";
 
     public static final Logger logger = Logger.getLogger(LuceneSearch.class);
 
-    protected Session session;
+    protected ILuceneIndexToolProvider toolProvider;
 
     protected IndexSearcher searcher;
 
-    private SortField[] sortFields;
+    protected SortField[] sortFields;
 
     private Class<? extends CdmBase> directorySelectClass;
 
+    private Filter filter = null;
+
     protected Class<? extends CdmBase> getDirectorySelectClass() {
         return pushAbstractBaseTypeDown(directorySelectClass);
     }
@@ -76,11 +68,25 @@ public class LuceneSearch {
     /**
      * classFilter
      */
-    private Class<? extends CdmBase> clazz;
+    protected Class<? extends CdmBase> cdmTypeRestriction;
+
 
+    public Class<? extends CdmBase> getCdmTypRestriction() {
+        return cdmTypeRestriction;
+    }
 
-    public Class<? extends CdmBase> getClazz() {
-        return clazz;
+    /**
+     * @return the filter
+     */
+    public Filter getFilter() {
+        return filter;
+    }
+
+    /**
+     * @param filter the filter to set
+     */
+    public void setFilter(Filter filter) {
+        this.filter = filter;
     }
 
     /**
@@ -88,7 +94,7 @@ public class LuceneSearch {
      * <code>directorySelectClass</code> the Class is set to <code>null</code>
      * @param clazz
      */
-    public void setClazz(Class<? extends CdmBase> clazz) {
+    public void setCdmTypRestriction(Class<? extends CdmBase> clazz) {
 
         /*
          * NOTE:
@@ -98,7 +104,7 @@ public class LuceneSearch {
         if(clazz != null && clazz.equals(directorySelectClass)){
             clazz = null;
         }
-        this.clazz = clazz;
+        this.cdmTypeRestriction = clazz;
     }
 
     /**
@@ -127,40 +133,41 @@ public class LuceneSearch {
     /**
      * @param session
      */
-    public LuceneSearch(Session session, Class<? extends CdmBase> directorySelectClass) {
-         this.session = session;
+    public LuceneSearch(ILuceneIndexToolProvider toolProvider, Class<? extends CdmBase> directorySelectClass) {
+         this.toolProvider = toolProvider;
          this.directorySelectClass = directorySelectClass;
     }
 
     /**
      * @param session
      */
-    public LuceneSearch(Session session, String groupByField, Class<? extends CdmBase> directorySelectClass) {
-         this.session = session;
-         this.directorySelectClass = directorySelectClass;
-         this.groupByField = groupByField;
+    public LuceneSearch(ILuceneIndexToolProvider toolProvider, String groupByField, Class<? extends CdmBase> directorySelectClass) {
+        this.toolProvider = toolProvider;
+        this.directorySelectClass = directorySelectClass;
+        this.groupByField = groupByField;
     }
 
     /**
      * TODO the abstract base class DescriptionElementBase can not be used, so
-     * we are using an arbitraty subclass to find the DirectoryProvider, future
+     * we are using an arbitrary subclass to find the DirectoryProvider, future
      * versions of hibernate search my allow using abstract base classes see
      * {@link http://stackoverflow.com/questions/492184/how-do-you-find-all-subclasses-of-a-given-class-in-java}
      *
      * @param type must not be null
      * @return
      */
-    protected Class<? extends CdmBase> pushAbstractBaseTypeDown(Class<? extends CdmBase> type) {
+    private Class<? extends CdmBase> pushAbstractBaseTypeDown(Class<? extends CdmBase> type) {
+        Class<? extends CdmBase> returnType = type;
         if (type.equals(DescriptionElementBase.class)) {
-            type = TextData.class;
+            returnType = TextData.class;
         }
         if (type.equals(TaxonBase.class)) {
-            type = Taxon.class;
+            returnType = Taxon.class;
         }
         if (type.equals(TaxonNameBase.class)) {
-            type = NonViralName.class;
+            returnType = NonViralName.class;
         }
-        return type;
+        return returnType;
     }
 
     protected LuceneSearch() {
@@ -172,42 +179,26 @@ public class LuceneSearch {
      */
     public IndexSearcher getSearcher() {
         if(searcher == null){
-            searcher = new IndexSearcher(getIndexReader());
+            searcher = new IndexSearcher(toolProvider.getIndexReaderFor(directorySelectClass));
             searcher.setDefaultFieldSortScoring(true, true);
         }
         return searcher;
     }
 
     /**
-     * @return
-     */
-    public IndexReader getIndexReader() {
-        SearchFactory searchFactory = Search.getFullTextSession(session).getSearchFactory();
-        IndexReader reader = searchFactory.getIndexReaderAccessor().open(getDirectorySelectClass());
-        return reader;
-    }
-
-    /**
-     * @return
-     */
-    public QueryParser getQueryParser() {
-        Analyzer analyzer = getAnalyzer();
-        QueryParser parser = new QueryParser(Configuration.luceneVersion,  "titleCache", analyzer);
-        return parser;
-    }
-
-    /**
-     * @return
+     * Convenience method which delegated the call to the available
+     * {@link ILuceneIndexToolProvider#getAnalyzerFor(Class)} method.
+     *
+     * @return the Analyzer suitable for the <code>directorySelectClass</code>
+     * of the LuceneSearch
      */
     public Analyzer getAnalyzer() {
-        SearchFactory searchFactory = Search.getFullTextSession(session).getSearchFactory();
-        Analyzer analyzer = searchFactory.getAnalyzer(getDirectorySelectClass());
-        return analyzer;
+        return toolProvider.getAnalyzerFor(directorySelectClass);
     }
 
     /**
      * @param luceneQueryString
-     * @param clazz the type as additional filter criterion
+     * @param cdmTypeRestriction the type as additional filter criterion
      * @param pageSize if the page size is null or in an invalid range it will be set to MAX_HITS_ALLOWED
      * @param pageNumber a 0-based index of the page to return, will default to 0 if null or negative.
      * @return
@@ -229,7 +220,7 @@ public class LuceneSearch {
      */
     public Query parse(String luceneQueryString) throws ParseException {
         logger.debug("luceneQueryString to be parsed: " + luceneQueryString);
-        Query luceneQuery = getQueryParser().parse(luceneQueryString);
+        Query luceneQuery = toolProvider.getQueryParserFor(directorySelectClass).parse(luceneQueryString);
         return luceneQuery;
     }
 
@@ -241,12 +232,10 @@ public class LuceneSearch {
     public TopDocs executeSearch(int maxNoOfHits) throws IOException {
         Query fullQuery = expandQuery();
         logger.info("lucene query string to be parsed: " + fullQuery.toString());
-        return getSearcher().search(fullQuery, maxNoOfHits);
+        return getSearcher().search(fullQuery, filter, maxNoOfHits);
 
     }
     /**
-     * @param luceneQuery
-     * @param clazz the type as additional filter criterion
      * @param pageSize if the page size is null or in an invalid range it will be set to MAX_HITS_ALLOWED
      * @param pageNumber a 0-based index of the page to return, will default to 0 if null or negative.
      * @return
@@ -284,9 +273,14 @@ public class LuceneSearch {
         }
 
         // perform the search (needs two passes for grouping)
+        if(logger.isDebugEnabled()){
+            logger.debug("Grouping: sortFields=" + sortFields + ", groupByField=" + groupByField +
+                    ", groupSort=" + groupSort + ", withinGroupSort=" + withinGroupSort + ", limit=" + limit + ", maxDocsPerGroup="+ maxDocsPerGroup);
+        }
         // - first pass
         TermFirstPassGroupingCollector firstPassCollector = new TermFirstPassGroupingCollector(groupByField, withinGroupSort, limit);
-        getSearcher().search(fullQuery, firstPassCollector);
+
+        getSearcher().search(fullQuery, filter , firstPassCollector);
         Collection<SearchGroup<String>> topGroups = firstPassCollector.getTopGroups(0, true); // no offset here since we need the first item for the max score
 
         if (topGroups == null) {
@@ -297,37 +291,32 @@ public class LuceneSearch {
         boolean getMaxScores = true;
         boolean fillFields = true;
         TermAllGroupsCollector allGroupsCollector = new TermAllGroupsCollector(groupByField);
-        TermSecondPassGroupingCollector secondPassCollector = new TermSecondPassGroupingCollector(groupByField, topGroups, groupSort, withinGroupSort, maxDocsPerGroup , getScores, getMaxScores, fillFields);
-        getSearcher().search(fullQuery, MultiCollector.wrap(secondPassCollector, allGroupsCollector));
+        TermSecondPassGroupingCollector secondPassCollector = new TermSecondPassGroupingCollector(
+                groupByField, topGroups, groupSort, withinGroupSort, maxDocsPerGroup , getScores, getMaxScores, fillFields
+                );
+        getSearcher().search(fullQuery, filter, MultiCollector.wrap(secondPassCollector, allGroupsCollector));
 
         TopGroups<String> groupsResult = secondPassCollector.getTopGroups(0); // no offset here since we need the first item for the max score
 
         // get max score from very first result
         float maxScore = groupsResult.groups[0].maxScore;
+        if(logger.isDebugEnabled()){
+            logger.debug("TopGroups: maxScore=" + maxScore + ", offset=" + offset +
+                    ", totalGroupCount=" + allGroupsCollector.getGroupCount() + ", totalGroupedHitCount=" + groupsResult.totalGroupedHitCount);
+        }
         TopGroupsWithMaxScore topGroupsWithMaxScore = new TopGroupsWithMaxScore(groupsResult, offset, allGroupsCollector.getGroupCount(), maxScore);
 
         return topGroupsWithMaxScore;
     }
 
     /**
-     * @param clazz
+     * expands the query by adding a type restriction if the
+     * <code>cdmTypeRestriction</code> is not <code>NULL</code>
      */
     protected Query expandQuery() {
         Query fullQuery;
-        if(clazz != null){
-            BooleanQuery filteredQuery = new BooleanQuery();
-            BooleanQuery classFilter = new BooleanQuery();
-
-            Term t = new Term(ProjectionConstants.OBJECT_CLASS, clazz.getName());
-            TermQuery termQuery = new TermQuery(t);
-
-            classFilter.setBoost(0);
-            classFilter.add(termQuery, BooleanClause.Occur.SHOULD);
-
-            filteredQuery.add(this.query, BooleanClause.Occur.MUST);
-            filteredQuery.add(classFilter, BooleanClause.Occur.MUST);
-
-            fullQuery = filteredQuery;
+        if(cdmTypeRestriction != null){
+            fullQuery = QueryFactory.addTypeRestriction(query, cdmTypeRestriction);
         } else {
             fullQuery = this.query;
         }
